import java.awt.*;
import java.lang.*;
import java.io.*;

	class Cesi1Gui extends Frame {
		TextField a1,a2,a3,a4,a5,a6;
		Button c1,c2,c3;
		Label l1,l2,l3,l4,l5,l6;
		Cesi1Calculs calcul = null ;
		SimpleDataViewer sdv1 = null;
		SimpleDataViewer sdv2 = null;
		SimpleDataViewer sdv3 = null;
		SimpleDataViewer sdv4 = null;
		SimpleDataViewer sdv5 = null;
		String nom = "sensenom.dat";
		float dt = 0.05f;
		int imax = 10;
		float ji = 0.0001f;
		float pluja = 1.0f;
		float ym = 1.0f;
		float crei = 0.0f;

		Cesi1Gui(String windowTitle) {
			super(windowTitle);
		}

		public void init() {
			setLayout(new GridLayout(0,3,10,10));
			a1 = new TextField(Float.toString(dt));
			a2 = new TextField(Integer.toString(imax));
			a3 = new TextField(Float.toString(ji));
			a4 = new TextField(Float.toString(pluja));
			a5 = new TextField(Float.toString(ym));
			a6 = new TextField(Float.toString(crei));
			c1 = new Button("Calcula");
			c2 = new Button("Desa");
			c3 = new Button("Abandona");
			l1 = new Label("Pas de temps (d)");
			l2 = new Label("Passos que vols calcular");
			l3 = new Label("Concentracio a l'aire (Bq/m^3)");
			l4 = new Label("Precipitacio (mm/d)");
			l5 = new Label("Densitat de vegetacio (kg/m^3)");
			l6 = new Label("Factor de creixement diari");
			add(l1);
			add(l2);
			add(l3);
			add(a1);
			add(a2);
			add(a3);
			add(l4);
			add(l5);
			add(l6);
			add(a4);
			add(a5);
			add(a6);
			add(c1);
			add(c2);
			add(c3);
			pack();
			c2.disable();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcula"))
				calcular();
			if(label.equals("Desa"))
				guardar();
			if(label.equals("Abandona"))
				System.exit(0);
			return true;
		}

		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			Float f1,f3,f4,f5,f6;
			double x0[],y00[],y01[],y02[],y03[],y04[];
			int m;

			if(sdv1!=null)sdv1.hide();
			if(sdv2!=null)sdv2.hide();
			if(sdv3!=null)sdv3.hide();
			if(sdv4!=null)sdv4.hide();
			if(sdv5!=null)sdv5.hide();
			sdv1 = new SimpleDataViewer("Visor de dades",1);
			sdv2 = new SimpleDataViewer("Visor de dades",1);
			sdv3 = new SimpleDataViewer("Visor de dades",1);
			sdv4 = new SimpleDataViewer("Visor de dades",1);
			sdv5 = new SimpleDataViewer("Visor de dades",1);
			sdv1.init();
			sdv2.init();
			sdv3.init();
			sdv4.init();
			sdv5.init();
			sdv1.tpt.frameWidth = 475;
			sdv2.tpt.frameWidth = 475;
			sdv3.tpt.frameWidth = 475;
			sdv4.tpt.frameWidth = 475;
			sdv5.tpt.frameWidth = 475;
			sdv1.tpt.tickSeparation1 = 20;
			sdv2.tpt.tickSeparation1 = 20;
			sdv3.tpt.tickSeparation1 = 20;
			sdv4.tpt.tickSeparation1 = 20;
			sdv5.tpt.tickSeparation1 = 20;
			sdv1.tpt.tickSeparation2 = 40;
			sdv2.tpt.tickSeparation2 = 40;
			sdv3.tpt.tickSeparation2 = 40;
			sdv4.tpt.tickSeparation2 = 40;
			sdv5.tpt.tickSeparation2 = 40;
			sdv1.grf.lx = "temps (d)";
			sdv2.grf.lx = "temps (d)";
			sdv3.grf.lx = "temps (d)";
			sdv4.grf.lx = "temps (d)";
			sdv5.grf.lx = "temps (d)";
			sdv1.grf.ly = "Conc. superficie (Bq/m2)";
			sdv2.grf.ly = "Conc. capa 1 (Bq/m2)";
			sdv3.grf.ly = "Conc. capa 2 (Bq/m2)";
			sdv4.grf.ly = "Conc. vegetacio ext. (Bq/m2)";
			sdv5.grf.ly = "Conc. vegeracio int. (Bq/m2)";
			
			f1 = Float.valueOf(a1.getText());
			f3 = Float.valueOf(a3.getText());
			f4 = Float.valueOf(a4.getText());
			f5 = Float.valueOf(a5.getText());
			f6 = Float.valueOf(a6.getText());
			dt = f1.floatValue();
			imax = Integer.parseInt(a2.getText());
			ji = f3.floatValue();
			pluja = f4.floatValue();
			ym = f5.floatValue();
			crei = f6.floatValue();
			calcul = new Cesi1Calculs(dt,imax,ji,pluja,ym,crei);
			c2.enable();
	
			x0 = new double[imax];
			y00 = new double[imax];
			y01 = new double[imax];
			y02 = new double[imax];
			y03 = new double[imax];
			y04 = new double[imax];
			
			for(m=0;m<imax;m++) {
				x0[m] = calcul.temps[m];
			}
			
			for(m=0;m<imax;m++) {
				y00[m] = calcul.conc[m][0];
			}
			
			sdv1.grf.cjt[0].initializeColor(1);
			sdv1.grf.cjt[0].initializeCoordinates(x0,y00);
			sdv1.grf.cjt[0].pointType = 0;
			sdv1.show();
			
			for(m=0;m<imax;m++) {
				y01[m] = calcul.conc[m][1];
			}
			
			sdv2.grf.cjt[0].initializeColor(1);
			sdv2.grf.cjt[0].initializeCoordinates(x0,y01);
			sdv2.grf.cjt[0].pointType = 0;
			sdv2.show();
			
			for(m=0;m<imax;m++) {
				y02[m] = calcul.conc[m][2];
			}
			
			sdv3.grf.cjt[0].initializeColor(1);
			sdv3.grf.cjt[0].initializeCoordinates(x0,y02);
			sdv3.grf.cjt[0].pointType = 0;
			sdv3.show();
			
			for(m=0;m<imax;m++) {
				y03[m] = calcul.conc[m][3];
			}
			
			sdv4.grf.cjt[0].initializeColor(1);
			sdv4.grf.cjt[0].initializeCoordinates(x0,y03);
			sdv4.grf.cjt[0].pointType = 0;
			sdv4.show();
			
			for(m=0;m<imax;m++) {
				y04[m] = calcul.conc[m][4];
			}
			
			sdv5.grf.cjt[0].initializeColor(1);
			sdv5.grf.cjt[0].initializeCoordinates(x0,y04);
			sdv5.grf.cjt[0].pointType = 0;
			sdv5.show();
		}

		public void guardar() {
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals
			int k,m;

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						
						for(m=0;m<imax;m++) {
							linia=Double.toString(calcul.temps[m]) + " " + Double.toString(calcul.conc[m][0]) + " " + Double.toString(calcul.conc[m][1]) + " " + Double.toString(calcul.conc[m][2]) + " " + Double.toString(calcul.conc[m][3]) + " " + Double.toString(calcul.conc[m][4]) + "\n";
							sortida.write(linia);
						}
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			Cesi1DialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;

			if (confirmar == null)
				confirmar = new Cesi1DialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals
			File fitxer;
			String nomdirectori = "./";

			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Desa",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;
		}

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
        		}
        		return super.handleEvent(evt);
		}
	}

	class Cesi1DialegConfirmar extends Dialog {
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		Cesi1DialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirma",true);
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.la");
			l1 = new Label ("  El fitxer ja existeix. Vols escriure a sobre?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) {
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.la")) {
				opcio = false;
				hide();
			}
			return true;
		}
		
		public boolean getOpcio() {
		return opcio;
		}
	}

class Cesi1 {

	public static void main(String args[]) {
		Cesi1Gui cesi1 = null;		// Declaraci d'instncies.

		cesi1 = new Cesi1Gui("Cesi1");
		cesi1.init();
		cesi1.show();
	}
}